.include "2313def.inc"



	rjmp reset
.org 0x003
	rjmp Compar
.org 0x005
	rjmp Del_20
	rjmp Indicat


	
.def	cifra1	=r11	;  
.def	cifra2	=r12	;
.def	cifra3	=r13	;
.def	cifra4	=r14	;
.def	cifra5	=r19	;
.def	cifra6	=r20	;
.def	cifra7	=r21	;
.def	cifra8	=r10	;
.def	cifra9	=r15	;
.def	catod	=r22
.def	cifra11	=r1	;    
.def	cifra21	=r2	;
.def	cifra31	=r3	;
.def	cifra41	=r4	;
.def	cifra51	=r5	;
.def	cifra61	=r6	;
.def	cifra71=r7
.def	cifra81	=r8
.def	cifra91	=r9
.def	com	=r23	; 
.def	tel	=r9	; 
.def	cur	=r25	; 


reset:
	ldi r16,0x90		; 
	out SPL,r16		;
	ldi r16,0b11111111
	out DDRB,r16		; B.7 - 
	ldi r16,0b10010000	;
	out PORTB,r16		;
	ldi r16,0b01111011
	out DDRD,r16		;  D


	ldi r16,0b010000010	; 
	out TIMSK,r16
	ldi r16	,0b00000011	; 
	out TCCR1B,r16
	ldi r16,0b00000011	;
	out TCCR0,r16
	ldi r16,0b00000011
	out MCUCR,r16		;   
	ldi r16,0b00000000
	out GIMSK,r16		;    D.2

	ldi r16,5		;   
	mov tel,r16		; "All right"
	ldi cur,9		;

	ldi r18,0

	ldi r17,1
	sts 0x61,r17

	ldi r16,0b11011101
	out DDRB,r16		; B.1 -  (  )
	sbi PortB,1
	sbi PinB,1
	nop
	nop
	nop
	sbis PinB,1
	rjmp no_delay
	

	ldi r16,0b11011111
	out DDRB,r16		; B.1 -  (  )

	ldi r17,data_void
	mov cifra9,r17
	ldi r17,data_void
	mov cifra8,r17
	ldi r17,data_d
	mov cifra7,r17
	ldi r17,data_E
	mov cifra6,r17
	ldi r17,data_L
	mov cifra5,r17
	ldi r17,data_A
	mov cifra4,r17
	ldi r17,data_Y
	mov cifra3,r17
	ldi r17,data_void
	mov cifra2,r17
	ldi r17,data_void
	mov cifra1,r17


	sei			; 
	
	ldi r17,25
	mov cifra31,r17
d4:	ldi r17,0xff
	mov cifra41,r17
d3:	mov cifra51,r17
d2:	mov cifra61,r17
d1:	dec cifra61
	brne d1
	dec cifra51
	brne d2
	dec cifra41
	brne d3
	dec cifra31
	brne d4

no_delay:
	ldi r16,0b11011111
	out DDRB,r16		; B.1 -  (  )
	sei

	ldi r17,data_A
	mov cifra9,r17
	ldi r17,data_L
	mov cifra8,r17
	ldi r17,data_L
	mov cifra7,r17
	ldi r17,data_void
	mov cifra6,r17
	ldi r17,data_r
	mov cifra5,r17
	ldi r17,data_I
	mov cifra4,r17
	ldi r17,data_G
	mov cifra3,r17
	ldi r17,d_h
	mov cifra2,r17
	ldi r17,data_t
	mov cifra1,r17

	sts 0x60,r18

L200:	
	lds r17,0x60
	sbrs r17,0
	rjmp L200

key:
	sbrc r17,1
	rjmp L200
	cpi com,0b00001110
	breq comand0
	cpi com,0b00001101
	breq comand1
	cpi com,0b00001011
	breq comand2
	cpi com,0b00000111
	breq comand_far
	rjmp L200

comand_far:
	rjmp comand3


comand0:		; 
	rcall redact
	ldi YH,0
	mov YL,cur
	ld r17,Y
	cpi r17,11
	brne com02
	st Y,r24
	rcall segm
com02:
	dec cur
	cpi cur,0
	brne com01
	ldi cur,9
com01:
	ldi r17,3
	sts 0x60,r17
	rjmp L200


comand1:		;
	rcall redact
	ldi YH,0
	mov YL,cur
	ld r17,Y
	cpi r17,11
	brne com12
	mov r17,r24
com12:
	inc r17
	st Y,r17
com14:
	cpi cur,9
	brne com13
	rcall Read_num
	cpi r17,4
	brne com11
	ldi r17,1
	st Y,r17
	rcall Read_num
	rjmp com11
com13:
	cpi r17,11
	brne com11
	ldi r17,0
	st Y,r17
com11:	rcall segm
	ldi r17,3
	sts 0x60,r17
	rjmp L200


comand2:		;  EEPROM
	rcall redact
	ldi YH,0
	mov YL,cur
	ld r17,Y
	cpi r17,11
	brne com23
	st Y,r24
	rcall segm
com23:
	mov r17,cifra91
	cpi r17,1
	brne com21
	ldi r18,0
	rcall Write_num
	rjmp com2_end
com21:
	cpi r17,2
	brne com22
	ldi r18,8
	rcall Write_num
	rjmp com2_end
com22:
	cpi r17,3
	brne com2_end
	ldi r18,16
	rcall Write_num
com2_end:
	ldi r17,3
	sts 0x60,r17
	rjmp L200


comand3:		;
	ldi r17,data_d
	mov cifra9,r17
	ldi r17,data_I
	mov cifra8,r17
	ldi r17,data_S
	mov cifra7,r17
	ldi r17,data_t
	mov cifra6,r17
	ldi r17,d_u
	mov cifra5,r17
	ldi r17,data_r
	mov cifra4,r17
	ldi r17,data_b
	mov cifra3,r17
	ldi r17,data_E
	mov cifra2,r17
	ldi r17,data_d
	mov cifra1,r17
again:	rcall Call
	ldi r17,3
	sts 0x60,r17
	rjmp L200



redact:
	ldi r17,0
	sts 0x61,r17
	mov r17,tel
	cpi r17,5
	brne red1
	ldi r17,1
	mov tel,r17
	mov cifra91,tel
	rcall Read_num
	rcall segm
red1:
	ret





;*********************************************
;***		        ***
;*********************************************

Indicat:
	in r16,SREG
	push r16

	cpi catod,0
	breq ind1
	cpi catod,1
	breq ind2
	cpi catod,2
	breq ind3
	cpi catod,3
	breq ind4
	cpi catod,4
	breq ind04
	cpi catod,5
	breq ind03
	cpi catod,6
	breq ind02
	cpi catod,7
	brne ind01
	rjmp ind8
ind01:	rjmp ind9

ind02:	rjmp ind7

ind03:	rjmp ind6

ind04:	rjmp ind5

ind1:
	ldi r16,1
	mov catod,r16
	cbi PortB,3
	cbi PortB,2
	cbi PortB,1
	sbi PortB,0
	mov r16,cifra8
	rjmp ind_end

ind2:
	ldi r16,2
	mov catod,r16
	cbi PortB,3
	cbi PortB,2
	sbi PortB,1
	cbi PortB,0
	mov r16,cifra7
	rjmp ind_end

ind3:
	ldi r16,3
	mov catod,r16
	cbi PortB,3
	cbi PortB,2
	sbi PortB,1
	sbi PortB,0
	mov r16,cifra6
	rjmp ind_end

ind4:
	ldi r16,4
	mov catod,r16
	cbi PortB,3
	sbi PortB,2
	cbi PortB,1
	cbi PortB,0
	mov r16,cifra5
	rjmp ind_end

ind5:
	ldi r16,5
	mov catod,r16
	cbi PortB,3
	sbi PortB,2
	cbi PortB,1
	sbi PortB,0
	mov r16,cifra4
	rjmp ind_end

ind6:
	ldi r16,6
	mov catod,r16
	cbi PortB,3
	sbi PortB,2
	sbi PortB,1
	cbi PortB,0
	mov r16,cifra3
	rjmp ind_end

ind7:
	ldi r16,7
	mov catod,r16
	cbi PortB,3
	sbi PortB,2
	sbi PortB,1
	sbi PortB,0
	mov r16,cifra2
	rjmp ind_end

ind8:
	ldi r16,8
	mov catod,r16
	sbi PortB,3
	cbi PortB,2
	cbi PortB,1
	cbi PortB,0
	mov r16,cifra1
	rjmp ind_end

ind9:
				; 
	ldi r16,0b11110000
	out DDRB,r16		; B.1...B.3 - 
	ldi r16,0b10001111
	sbi PortB,3
	sbi PortB,2
	sbi PortB,1
	sbi PortB,0
	sbi PinB,3
	sbi PinB,2
	sbi PinB,1
	sbi PinB,0
	nop
	nop
	nop
	sbic PinB,0
	ldi r16,0b00001111
	sbis PinB,0
	ldi r16,0b00001110
	sbis PinB,1
	ldi r16,0b00001101
	sbis PinB,2
	ldi r16,0b00001011
	sbis PinB,3
	ldi r16,0b00000111

	cpi r16,0b00001111
	breq ind91
	lds r26,0x60
	sbrc r26,1
	rjmp ind92
	mov com,r16
	ldi r16,0b00000001
	sts 0x60,r16
	rjmp ind92
ind91:	ldi com,1
	clr r16
	sts 0x60,r16
ind92:
	ldi r16,0b11111111
	out DDRB,r16
	ldi r16,0
	mov catod,r16
	cbi PortB,3
	cbi PortB,2
	cbi PortB,1
	cbi PortB,0
	mov r16,cifra9

ind_end:
	sbrc r16,2
	sbi PortB,7
	sbrs r16,2
	cbi PortB,7
	andi r16,0b11111011
	out PortD,r16

	pop r16
	out SREG,r16
	reti




;*********************************************
;****	  BCD-7segm	***
;*********************************************

segm:
	ldi ZL,low(data*2)
	ldi ZH,high(data*2)
	CLC
	adc ZL,cifra11
	brcc segm1
	inc ZH
segm1:
	lpm
	mov cifra1,r0
	ldi ZL,low(data*2)
	ldi ZH,high(data*2)
	CLC
	adc ZL,cifra21
	brcc segm2
	inc ZH
segm2:
	lpm
	mov cifra2,r0
	ldi ZL,low(data*2)
	ldi ZH,high(data*2)
	CLC
	adc ZL,cifra31
	brcc segm3
	inc ZH
segm3:
	lpm
	mov cifra3,r0
	ldi ZL,low(data*2)
	ldi ZH,high(data*2)
	CLC
	adc ZL,cifra41
	brcc segm4
	inc ZH
segm4:
	lpm
	mov cifra4,r0
	ldi ZL,low(data*2)
	ldi ZH,high(data*2)
	CLC
	adc ZL,cifra51
	brcc segm5
	inc ZH
segm5:
	lpm
	mov cifra5,r0
	ldi ZL,low(data*2)
	ldi ZH,high(data*2)
	CLC
	adc ZL,cifra61
	brcc segm6
	inc ZH
segm6:
	lpm
	mov cifra6,r0
	ldi ZL,low(data*2)
	ldi ZH,high(data*2)
	CLC
	adc ZL,cifra71
	brcc segm7
	inc ZH
segm7:
	lpm
	mov cifra7,r0
	ldi ZL,low(data*2)
	ldi ZH,high(data*2)
	CLC
	adc ZL,cifra81
	brcc segm8
	inc ZH
segm8:
	lpm
	mov cifra8,r0
	ldi ZL,low(data*2)
	ldi ZH,high(data*2)
	CLC
	adc ZL,cifra91
	brcc segm9
	inc ZH
segm9:
	lpm
	mov cifra9,r0


	ret




;*********************************************
;***		 500 		***
;*********************************************

Del_20:
	in r16,SREG
	push r16

	lds r16,0x61
	sbrc r16,0
	rjmp del_202

	ldi YH,0
	mov YL,cur
	ld r16,Y
	cpi r16,11
	brne del_201
	st Y,r24
	rcall segm
	rjmp del_end
del_201:
	mov r24,r16
	ldi r16,11
	st Y,r16
	rcall segm
	rjmp del_end

del_202:
	set

del_end:
	pop r16
	bld r16,6
	out SREG,r16
	reti

;*********************************************
;***		EEPROM subroutines		***
;*********************************************


;***** Subroutine register variables

.def	EEdata	=r17		;data byte to write to EEPROM
.def	EEadr	=r18		;address low byte to write to

;***** Code

Write_num:
	mov EEdata,cifra11
	rcall EEWrite
	inc EEadr

	mov EEdata,cifra21
	rcall EEWrite
	inc EEadr

	mov EEdata,cifra31
	rcall EEWrite
	inc EEadr

	mov EEdata,cifra41
	rcall EEWrite
	inc EEadr

	mov EEdata,cifra51
	rcall EEWrite
	inc EEadr

	mov EEdata,cifra61
	rcall EEWrite
	inc EEadr

	mov EEdata,cifra71
	rcall EEWrite
	inc EEadr

	mov EEdata,cifra81
	rcall EEWrite
	ldi r17,0b00111011
	mov cifra9,r17
	ret



EEWrite:
	sbic	EECR,EEWE	;if EEWE not clear
	rjmp	EEWrite		;    wait more

	out	EEAR,EEadr	;output address for 1200, commented out !


	out	EEDR,EEdata	;output data
	sbi 	EECR,EEMWE	;set master write enable, remove if 1200 is used	
	sbi	EECR,EEWE	;set EEPROM Write strobe
				;This instruction takes 4 clock cycles since
				;it halts the CPU for two clock cycles
	ret


Read_num:
	mov r17,tel
	cpi r17,1
	brne rn1
	ldi EEadr,0
	rjmp read
rn1:	cpi r17,2
	brne rn2
	ldi EEadr,8
	rjmp read
rn2:	cpi r17,3
	brne read_end
	ldi EEadr,16
read:
	rcall EERead
	mov cifra11,EEdata
	inc EEadr

	rcall EERead
	mov cifra21,EEdata
	inc EEadr

	rcall EERead
	mov cifra31,EEdata
	inc EEadr

	rcall EERead
	mov cifra41,EEdata
	inc EEadr

	rcall EERead
	mov cifra51,EEdata
	inc EEadr

	rcall EERead
	mov cifra61,EEdata
	inc EEadr

	rcall EERead
	mov cifra71,EEdata
	inc EEadr

	rcall EERead
	mov cifra81,EEdata
	mov cifra91,tel
read_end:	
	ret


EERead:
	sbic	EECR,EEWE	;if EEWE not clear
	rjmp	EERead		;    wait more
	out	EEAR,EEadr	;output address for 1200, commented out !

	sbi	EECR,EERE	;set EEPROM Read strobe
				;This instruction takes 4 clock cycles since
				;it halts the CPU for two clock cycles
	in	EEdata,EEDR	;get data
	ret



;*********************************************
;***	   	***
;*********************************************


Call:
	ldi r17,1
	sts 0x61,r17

	ldi r17	,0b00000010	;  ~50 ms
	out TCCR1B,r17

	ldi r17,1		;  
	mov tel,r17

Call_next:
	rcall Read_num

	sbi PortB,6		; 
sbi PortB,5
	ldi r18,30
	rcall wait		; 1,5 
	cbi PortB,6		; 
cbi PortB,5
	rcall wait		; 1,5 
				;  
				;  
	sbi PortB,6
	sbi PortB,5
	rcall wait
	ldi YH,0
	ldi YL,8
	ld r17,Y
	cpi r17,10
	breq imp		;    
	rjmp fed		;,    
imp:
	ldi r18,1		;  
	ld r17,Y
	dec YL
	cpi r17,0
	brne imp1
	ldi r17,10
	rjmp imp2
imp1:
	cpi r17,10
	breq imp

imp2:
	cbi PortB,6
	cbi PortB,5
	rcall wait
	sbi PortB,6
	sbi PortB,5
	rcall wait
	dec r17
	cpi r17,0
	brne imp2
	ldi r18,15
	rcall wait
	cpi YL,0
	brne imp		;  

	sbi PortB,6
;	cbi PortB,5
	sbi PortB,5
				;  
	rcall wait


;	rcall signal		;   
;	cpi r17,0		;   r17 -  
;	brne imp3		;r17 = 0 -   



imp3:	
	cbi PortB,4		;Speach
	ldi r18,10
	rcall wait
	sbi PortB,4
	
	ldi r18,200
	rcall wait
	cbi PortB,4
	ldi r18,10
	rcall wait
	sbi PortB,4

	ldi r18,200
	rcall wait
	cbi PortB,4
	ldi r18,10
	rcall wait
	sbi PortB,4

	ldi r18,200
	rcall wait
	cbi PortB,4
	ldi r18,10
	rcall wait
	sbi PortB,4

	ldi r18,200
	rcall wait
	cbi PortB,4
	ldi r18,10
	rcall wait
	sbi PortB,4
	ldi r18,200
	rcall wait

	cbi PortB,6		;  
	cbi PortB,5



	ldi r17	,0b00000010	;  ~50 ms
	out TCCR1B,r17
	mov r17,tel
	inc r17
	cpi r17,4
	brne imp5
	ldi r17,1
imp5:
	mov tel,r17
	rjmp Call_next		;


imp4:
	ret


;*********************************************
;***	  		***
;*********************************************

fed:
	ldi r18,1	; "8"
	ldi r17,8
fed1:	cbi PortB,6
	cbi PortB,5
	rcall wait
	sbi PortB,6
	sbi PortB,5
	rcall wait
	dec r17
	cpi r17,0
	brne fed1
	ldi r18,70	;    4 
	rcall wait	;

	ldi r18,1	; "9"
	ldi r17,9
fed2:	cbi PortB,6
	cbi PortB,5
	rcall wait
	sbi PortB,6
	sbi PortB,5
	rcall wait
	dec r17
	cpi r17,0
	brne fed2
	ldi r18,15
	rcall wait

	ldi r18,1	; "1"
	ldi r17,1
fed3:	cbi PortB,6
	cbi PortB,5
	rcall wait
	sbi PortB,6
	sbi PortB,5
	rcall wait
	dec r17
	cpi r17,0
	brne fed3
	ldi r18,15
	rcall wait

	
	rjmp imp		; 	




;*********************************************
;***		  		***
;*********************************************

Compar:
	reti








;****************************************************
;***	    	***
;****************************************************


signal:







			;  (t = r18*100ms)
wait:
	clt
	clr cur
wait1:	brtc wait1
	clt
	inc cur
	cp cur,r18
	brne wait1
	ret



data:
;	0		1		2		3
.db	0b01101111,	0b01000100,	0b00110111,	0b01010111

;	4		5		6		7
.db	0b01011100,	0b01011011,	0b01111011,	0b01000101

;	8		9
.db	0b01111111,	0b01011111

;			
.db	0b00000000,	0b00000000


;		  hcegfbda
.equ	data_A=	0b01111101
.equ	data_b=0b01111010
.equ	data_C=0b00101011
.equ	data_d=0b01110110
.equ	data_I=0b00101000
.equ	data_E=0b00111011
.equ	data_G=0b01101011
.equ	data_H=	0b01111100
.equ	d_h   =0b01111000
.equ	data_L=	0b00101010
.equ	data_n=0b01110000
.equ	data_O=	0b01101111
.equ	data_P=0b00111101
.equ	data_r=0b00110000
.equ	data_S=0b01011011
.equ	data_t=0b00111010
.equ	data_U=0b01101110
.equ	d_u   =0b01100010
.equ	data_Y=0b01011110
.equ	line  =0b00010000
.equ	data_void=0b00000000
